/*
 *
 * Author: Faheem Pervez <qwerty12>
 * Thanks to Javier S. Pedro <javispedro> and daperl.
 * (Most of) the compositing functions taken from hildon-desktop, (C)opyright Nokia Corporation
 * The final pixbuf to pass to gtk_window_set_icon() must be 64x54 (thanks javispedro!)
            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2004 Sam Hocevar
  14 rue de Plaisance, 75014 Paris, France
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO.


 *
 */

#include <gtk/gtk.h>
#include <hildon/hildon-window.h>

gboolean changeicon (GtkWidget *window)
{
  GError *error = NULL;
#if 0
  if(!gtk_window_set_icon_from_file(GTK_WINDOW(window), "web.png", &error))
  {
      g_fprintf(stderr, "%s\n", error->message);
      g_error_free(error);
  }
  return FALSE;
#endif

  GtkIconTheme *icon_theme;
  GdkPixbuf *pixbuff, *temp, *overlayedone;
  icon_theme = gtk_icon_theme_get_default();
  gint dest_width, dest_height;
  gint off_x, off_y;

  pixbuff = gtk_icon_theme_load_icon(icon_theme, "qgn_list_browser", 64, 0, &error);
  if(pixbuff == NULL)
  {
      g_fprintf(stderr, "%s\n", error->message);
      g_error_free(error); 
      return FALSE; /* We failed. Don't call this timeout function again. */
  }

  temp = gtk_icon_theme_load_icon(icon_theme, "qgn_indi_browser_active_state", 16, 0, &error);
  if(overlayedone == NULL)
  {
      g_fprintf(stderr, "%s\n", error->message);
      g_error_free(error); 
      return FALSE; /* We failed. Don't call this timeout function again. */
  }

  overlayedone = gdk_pixbuf_add_alpha (pixbuff, FALSE, 255, 255, 255);
  g_object_unref (pixbuff);

  dest_width = gdk_pixbuf_get_width (overlayedone);
  dest_height = gdk_pixbuf_get_height (overlayedone);

  off_x = dest_width - gdk_pixbuf_get_width (temp);
  off_y = dest_height - gdk_pixbuf_get_height (temp);

  gdk_pixbuf_composite (temp, overlayedone,
		        0, 0,
			dest_width, dest_height,
			off_x, off_y,
			1.0, 1.0,
			GDK_INTERP_BILINEAR,
			0xFF);
  g_object_unref(temp);
  gtk_window_set_icon(GTK_WINDOW(window), overlayedone);
  g_object_unref(overlayedone);

  return FALSE; /* We succeeded. Don't call this timeout function again. */
}

int main(int argc, char **argv)
{
  GtkWidget *window;

  gtk_init(&argc, &argv);

  window = hildon_window_new();
  g_set_application_name("Test");
  gtk_window_set_title(GTK_WINDOW(window), "Icon");
  gtk_timeout_add(5000, (GtkFunction) changeicon, window);
  gtk_widget_show(window);

  g_signal_connect_swapped(G_OBJECT(window), "destroy",
      G_CALLBACK(gtk_main_quit), NULL);

  gtk_main();

  return 0;
}